Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser.py	(revision 7240)
@@ -24,5 +24,5 @@
 from datetime import datetime, date
 from zope.authentication.interfaces import ILogout, IAuthentication
-from zope.component import getUtility
+from zope.component import getUtility, createObject
 from zope.formlib.widget import CustomWidgetFactory
 from zope.formlib.form import setUpEditWidgets
@@ -51,5 +51,6 @@
     )
 from waeup.sirp.interfaces import (
-    IWAeUPObject, ILocalRolesAssignable, IExtFileStore, IFileStoreNameChooser)
+    IWAeUPObject, ILocalRolesAssignable, IExtFileStore,
+    IFileStoreNameChooser, IPasswordValidator, IUserAccount)
 from waeup.sirp.permissions import get_users_with_local_roles
 from waeup.sirp.browser import DEFAULT_PASSPORT_IMAGE_PATH
@@ -61,17 +62,14 @@
 from waeup.sirp.widgets.objectwidget import (
     WAeUPObjectWidget, WAeUPObjectDisplayWidget)
-from waeup.sirp.applicants import ResultEntry, Applicant, get_applicant_data
+from waeup.sirp.applicants import Applicant, get_applicant_data
 from waeup.sirp.applicants.interfaces import (
-    IApplicant, IApplicantPrincipal,IApplicantEdit, IApplicantsRoot,
+    IApplicant, IApplicantEdit, IApplicantsRoot,
     IApplicantsContainer, IApplicantsContainerAdd, application_types_vocab,
     MAX_UPLOAD_SIZE,
     )
 from waeup.sirp.applicants.workflow import INITIALIZED, STARTED
-
-results_widget = CustomWidgetFactory(
-    WAeUPObjectWidget, ResultEntry)
-
-results_display_widget = CustomWidgetFactory(
-    WAeUPObjectDisplayWidget, ResultEntry)
+from waeup.sirp.students.viewlets import PrimaryStudentNavTab
+
+grok.context(IWAeUPObject) # Make IWAeUPObject the default context
 
 class ApplicantsRootPage(WAeUPPage):
@@ -228,5 +226,5 @@
         """Get a title for a context.
         """
-        return self.context.access_code
+        return self.context.application_number
 
 class ApplicantsAuthTab(PrimaryNavTab):
@@ -235,5 +233,5 @@
     grok.context(IWAeUPObject)
     grok.order(3)
-    grok.require('waeup.viewApplication')
+    grok.require('waeup.viewApplicationsTab')
     grok.template('primarynavtab')
     pnav = 3
@@ -263,4 +261,22 @@
     #    return tt
 
+class MyApplicationDataTab(PrimaryStudentNavTab):
+    """MyData-tab in primary navigation.
+    """
+    grok.order(3)
+    grok.require('waeup.viewMyApplicationDataTab')
+    grok.template('primarynavtab')
+    pnav = 3
+    tab_title = u'My Data'
+
+    @property
+    def link_target(self):
+        try:
+            container, application_number = self.request.principal.id.split('_')
+        except ValueError:
+            return
+        rel_link = '/applicants/%s/%s' % (container, application_number)
+        return self.view.application_url() + rel_link
+
 class ApplicantsContainerPage(WAeUPDisplayFormPage):
     """The standard view for regular applicant containers.
@@ -292,12 +308,12 @@
     text = 'Manage applicants container'
 
-class ApplicantLoginActionButton(ManageActionButton):
-    grok.order(2)
-    grok.context(IApplicantsContainer)
-    grok.view(ApplicantsContainerPage)
-    grok.require('waeup.Anonymous')
-    icon = 'login.png'
-    text = 'Login for applicants'
-    target = 'login'
+#class ApplicantLoginActionButton(ManageActionButton):
+#    grok.order(2)
+#    grok.context(IApplicantsContainer)
+#    grok.view(ApplicantsContainerPage)
+#    grok.require('waeup.Anonymous')
+#    icon = 'login.png'
+#    text = 'Login for applicants'
+#    target = 'login'
 
 class ApplicantsContainerManageFormPage(WAeUPEditFormPage):
@@ -394,4 +410,5 @@
         return del_local_roles(self,3,**data)
 
+# Not used anymore
 class ApplicantLoginPage(WAeUPPage):
     grok.context(IApplicantsContainer)
@@ -421,6 +438,6 @@
             self.flash('Entered credentials are invalid.')
             return
-        if not IApplicantPrincipal.providedBy(self.request.principal):
-            # Don't care if user is already authenticated as non-applicant
+#        if not IApplicantPrincipal.providedBy(self.request.principal):
+#            # Don't care if user is already authenticated as non-applicant
             return
 
@@ -470,8 +487,11 @@
 
         # Mark application as started
-        if IWorkflowState(self.context[pin]).getState() is INITIALIZED:
-            IWorkflowInfo(self.context[pin]).fireTransition('start')
+        #if IWorkflowState(self.context[pin]).getState() is INITIALIZED:
+        #    IWorkflowInfo(self.context[pin]).fireTransition('start')
 
         self.redirect(self.url(self.context[pin], 'edit'))
+        return
+
+    def render(self):
         return
 
@@ -482,5 +502,8 @@
     grok.require('waeup.manageApplication')
     grok.name('addapplicant')
-    grok.template('applicantaddpage')
+    #grok.template('applicantaddpage')
+    form_fields = grok.AutoFields(IApplicant).select(
+        'firstname', 'middlenames', 'lastname',
+        'email', 'phone')
     title = 'Applicants'
     label = 'Add applicant'
@@ -491,67 +514,12 @@
         return "Applicants Container: %s" % self.context.title
 
-    @property
-    def ac_prefix(self):
-        return self.context.ac_prefix
-
     @grok.action('Create application record')
     def addApplicant(self, **data):
-        ac_series = self.request.form.get('form.ac_series', None)
-        ac_number = self.request.form.get('form.ac_number', None)
-        pin = '%s-%s-%s' % (self.ac_prefix,ac_series,ac_number)
-        if not invalidate_accesscode(pin, comment=u"Invalidated by system"):
-            self.flash('%s is not a valid access code.' % pin)
-            self.redirect(self.url(self.context, '@@manage')+'#tab-2')
-            return
-        else:
-            # Create applicant record
-            applicant = Applicant()
-            applicant.access_code = pin
-            self.context[pin] = applicant
-        self.redirect(self.url(self.context[pin], 'manage'))
-        return
-
-class AccessCodeViewLink(LeftSidebarLink):
-    grok.order(1)
-    grok.require('waeup.Public')
-    icon = 'actionicon_view.png'
-    title = 'View Record'
-    target = '/@@index'
-
-    @property
-    def url(self):
-        if not IApplicantPrincipal.providedBy(self.request.principal):
-            return ''
-        access_code = getattr(self.request.principal,'access_code',None)
-        if access_code:
-            applicant_object = get_applicant_data(access_code)
-            return absoluteURL(applicant_object, self.request) + self.target
-        return ''
-
-class AccessCodeEditLink(AccessCodeViewLink):
-    grok.order(2)
-    grok.require('waeup.Public')
-    icon = 'actionicon_modify.png'
-    title = 'Edit Record'
-    target = '/@@edit'
-
-    @property
-    def url(self):
-        if not IApplicantPrincipal.providedBy(self.request.principal):
-            return ''
-        access_code = getattr(self.request.principal,'access_code',None)
-        if access_code:
-            applicant_object = get_applicant_data(access_code)
-            if applicant_object.locked:
-                return ''
-            return absoluteURL(applicant_object, self.request) + self.target
-        return ''
-
-class AccessCodeSlipLink(AccessCodeViewLink):
-    grok.order(3)
-    grok.require('waeup.Public')
-    icon = 'actionicon_pdf.png'
-    title = 'Download Slip'
-    target = '/application_slip.pdf'
+        applicant = createObject(u'waeup.Applicant', container = self.context)
+        self.applyData(applicant, **data)
+        self.context.addApplicant(applicant)
+        self.flash('Applicant record created.')
+        self.redirect(self.url(self.context[applicant.application_number], 'index'))
+        return
 
 class ApplicantDisplayFormPage(WAeUPDisplayFormPage):
@@ -561,5 +529,5 @@
     grok.template('applicantdisplaypage')
     form_fields = grok.AutoFields(IApplicant).omit(
-        'locked').omit('course_admitted')
+        'locked', 'course_admitted', 'password')
     form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')
     label = 'Applicant'
@@ -568,16 +536,24 @@
     def update(self):
         self.passport_url = self.url(self.context, 'passport.jpg')
-        return
+        # Mark application as started if applicant logs in for the first time
+        if IWorkflowState(self.context).getState() == INITIALIZED:
+            IWorkflowInfo(self.context).fireTransition('start')
+        return
+
+    @property
+    def hasPassword(self):
+        if self.context.password:
+            return 'set'
+        return 'unset'
 
     @property
     def title(self):
-        if self.request.principal.title == 'Applicant':
-            return u'Your Application Record'
-        return '%s' % self.context.access_code
+        return 'Application Record %s' % self.context.application_number
 
     @property
     def label(self):
         container_title = self.context.__parent__.title
-        return '%s Application Record' % container_title
+        return '%s Application Record %s' % (
+            container_title, self.context.application_number)
 
     def getCourseAdmitted(self):
@@ -607,5 +583,5 @@
     grok.require('waeup.viewApplication')
     form_fields = grok.AutoFields(IApplicant).omit(
-        'locked').omit('course_admitted')
+        'locked', 'course_admitted')
     form_fields['date_of_birth'].custom_widget = FriendlyDateDisplayWidget('le')
     prefix = 'form'
@@ -614,5 +590,6 @@
     def label(self):
         container_title = self.context.__parent__.title
-        return '%s Application Record' % container_title
+        return '%s Application Record %s' % (
+            container_title, self.context.application_number)
 
     def getCourseAdmitted(self):
@@ -710,4 +687,18 @@
     target = 'manage'
 
+class ApplicantEditActionButton(ManageActionButton):
+    grok.context(IApplicant)
+    grok.view(ApplicantDisplayFormPage)
+    grok.require('waeup.handleApplication')
+    text = 'Edit application record'
+    target ='edit'
+
+    @property
+    def target_url(self):
+        """Get a URL to the target...
+        """
+        if self.context.locked:
+            return
+        return self.view.url(self.view.context, self.target)
 
 def handle_img_upload(upload, context, view):
@@ -756,10 +747,11 @@
     @property
     def title(self):
-        return self.context.access_code
+        return 'Application Record %s' % self.context.application_number
 
     @property
     def label(self):
         container_title = self.context.__parent__.title
-        return '%s Application Form' % container_title
+        return '%s Application Form %s' % (
+            container_title, self.context.application_number)
 
     def getTransitions(self):
@@ -776,4 +768,13 @@
     @grok.action('Save')
     def save(self, **data):
+        form = self.request.form
+        password = form.get('password', None)
+        password_ctl = form.get('control_password', None)
+        if password:
+            validator = getUtility(IPasswordValidator)
+            errors = validator.validate_password(password, password_ctl)
+            if errors:
+                self.flash( ' '.join(errors))
+                return
         if self.passport_changed is False:  # False is not None!
             return # error during image upload. Ignore other values
@@ -782,9 +783,13 @@
         if changed_fields:
             changed_fields = reduce(lambda x,y: x+y, changed_fields.values())
+        else:
+            changed_fields = []
+        if self.passport_changed:
+            changed_fields.append('passport')
+        if password:
+            # Now we know that the form has no errors and can set password ...
+            IUserAccount(self.context).setPassword(password)
+            changed_fields.append('password')
         fields_string = ' + '.join(changed_fields)
-        if self.passport_changed:
-            fields_string += ' + passport'
-        #self.context._p_changed = True
-        form = self.request.form
         trans_id = form.get('transition', None)
         if trans_id:
@@ -804,5 +809,5 @@
     form_fields = grok.AutoFields(IApplicantEdit).omit(
         'locked', 'course_admitted', 'student_id',
-        'screening_score',
+        'screening_score', 'applicant_id'
         )
     form_fields['date_of_birth'].custom_widget = FriendlyDateWidget('le-year')
@@ -863,5 +868,5 @@
     grok.context(IApplicant)
     grok.view(ApplicantManageFormPage)
-    grok.require('waeup.manageApplication')
+    grok.require('waeup.viewApplication')
     icon = 'actionicon_view.png'
     text = 'View application record'
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicantdisplaypage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicantdisplaypage.pt	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicantdisplaypage.pt	(revision 7240)
@@ -11,9 +11,8 @@
 </div>
 
+<img src="" tal:attributes="src view/passport_url" />
+
 <table class="zebra">
   <tbody>
-    <tr>
-    <td><img src="" tal:attributes="src view/passport_url" /></td>
-    </tr>
     <tal:block repeat="widget view/widgets">
       <tr>
@@ -34,4 +33,12 @@
       </td>
     </tr>
+    <tr>
+      <td class="fieldname">
+          Password:
+      </td>
+      <td>
+          <tal:password replace="view/hasPassword" />
+      </td>
+    <tr>
   </tbody>
 </table>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicanteditpage.pt
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicanteditpage.pt	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/browser_templates/applicanteditpage.pt	(revision 7240)
@@ -23,5 +23,5 @@
   </div>
 
-  <table class="form-fields zebra">
+  <table class="zebra">
     <tbody>
       <tal:block repeat="widget view/widgets">
@@ -62,4 +62,16 @@
       </tr>
       <tr tal:condition="view/manage_applications">
+        <td class="label"><label>Password:</label></td>
+        <td>
+          <input name="password" type="password"  />
+        </td>
+      </tr>
+      <tr tal:condition="view/manage_applications">
+        <td class="label"><label>Retype password:</label></td>
+        <td>
+          <input name="control_password" type="password" />
+        </td>
+      </tr>
+      <tr tal:condition="view/manage_applications">
         <td class="label"><label>Application Transition:</label></td>
         <td>
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/container.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/container.py	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/container.py	(revision 7240)
@@ -24,5 +24,5 @@
 from waeup.sirp.applicants.interfaces import (
     IApplicantsContainer, IApplicantsContainerAdd,
-    IApplicantsContainerProvider,
+    IApplicantsContainerProvider, IApplicant
     )
 from waeup.sirp.utils.helpers import attrs_to_fields
@@ -83,4 +83,13 @@
         raise NotImplementedError()
 
+    def addApplicant(self, applicant):
+        """Add an applicant.
+        """
+        if not IApplicant.providedBy(applicant):
+            raise TypeError(
+                'ApplicantsContainers contain only IApplicant instances')
+        self[applicant.application_number] = applicant
+        return
+
 ApplicantsContainer = attrs_to_fields(ApplicantsContainer)
 
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/interfaces.py	(revision 7240)
@@ -29,5 +29,5 @@
 from zope.security.interfaces import IGroupClosureAwarePrincipal as IPrincipal
 from zc.sourcefactory.basic import BasicSourceFactory
-from waeup.sirp.interfaces import IWAeUPObject, year_range
+from waeup.sirp.interfaces import IWAeUPObject, year_range, validate_email
 from waeup.sirp.university.vocabularies import application_categories
 from waeup.sirp.students.vocabularies import (
@@ -42,15 +42,4 @@
 MAX_UPLOAD_SIZE = 1024 * 20
 
-# Define a valiation method for email addresses
-class NotAnEmailAddress(schema.ValidationError):
-    __doc__ = u"Invalid email address"
-
-check_email = re.compile(
-    r"[a-zA-Z0-9._%-]+@([a-zA-Z0-9-]+.)*[a-zA-Z]{2,4}").match
-def validate_email(value):
-    if not check_email(value):
-        raise NotAnEmailAddress(value)
-    return True
-
 class ApplicantContainerProviderSource(BasicSourceFactory):
     """A source offering all available applicants container types.
@@ -90,16 +79,4 @@
         return "%s - %s" % (
             factory.container_title, factory.container_description)
-
-class IResultEntry(IWAeUPObject):
-    subject = schema.TextLine(
-        title = u'Subject',
-        description = u'The subject',
-        required=False,
-        )
-    score = schema.TextLine(
-        title = u'Score',
-        description = u'The score',
-        required=False,
-        )
 
 class IApplicantsRoot(IWAeUPObject, IContainer):
@@ -263,5 +240,5 @@
     """The data for an applicant.
 
-    This is a base interface with no field (except ``reg_no``)
+    This is a base interface with no field
     required. For use with importers, forms, etc., please use one of
     the derived interfaces below, which set more fields to required
@@ -269,10 +246,9 @@
     """
     history = Attribute('Object history, a list of messages.')
-    state = Attribute('Returns the application state of an applicant')
+    state = Attribute('The application state of an applicant')
+    fullname = Attribute('The fullname of an applicant')
     application_date = Attribute('Date of submission, used for export only')
-
-    #def getApplicantsRootLogger():
-    #    """Returns the logger from the applicants root object
-    #    """
+    password = Attribute('Encrypted password of a applicant')
+    application_number = Attribute('The key under which the record is stored')
 
     def loggerInfo(ob_class, comment):
@@ -280,7 +256,14 @@
         """
 
+    applicant_id = schema.TextLine(
+        title = u'Applicant Id',
+        required = False,
+        readonly = True,
+        )
+
     reg_no = schema.TextLine(
         title = u'JAMB Registration Number',
         readonly = True,
+        required = False,
         )
     access_code = schema.TextLine(
@@ -329,5 +312,5 @@
     email = schema.ASCIILine(
         title = u'Email',
-        required = False,
+        required = True,
         constraint=validate_email,
         )
@@ -416,52 +399,4 @@
         )
 
-class IApplicantPrincipalInfo(IPrincipalInfo):
-    """Infos about principals that are applicants.
-    """
-    access_code = Attribute("The Access Code the user purchased")
-
-class IApplicantPrincipal(IPrincipal):
-    """A principal that is an applicant.
-
-    This interface extends zope.security.interfaces.IPrincipal and
-    requires also an `id` and other attributes defined there.
-    """
-    access_code = schema.TextLine(
-        title = u'Access Code',
-        description = u'The access code purchased by the user.',
-        required = True,
-        readonly = True)
-
-class IApplicantsFormChallenger(Interface):
-    """A challenger that uses a browser form to collect applicant
-       credentials.
-    """
-    loginpagename = schema.TextLine(
-        title = u'Loginpagename',
-        description = u"""Name of the login form used by challenger.
-
-        The form must provide an ``access_code`` input field.
-        """)
-
-    accesscode_field = schema.TextLine(
-        title = u'Access code field',
-        description = u'''Field of the login page which is looked up for
-                          access_code''',
-        default = u'access_code',
-        )
-
-
-class IApplicantSessionCredentials(Interface):
-    """Interface for storing and accessing applicant credentials in a
-       session.
-    """
-
-    def __init__(access_code):
-        """Create applicant session credentials."""
-
-    def getAccessCode():
-        """Return the access code."""
-
-
 class IApplicantsContainerProvider(Interface):
     """A provider for applicants containers.
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/permissions.py	(revision 7240)
@@ -29,4 +29,10 @@
     grok.name('waeup.viewApplication')
 
+class ViewApplicationsTab(grok.Permission):
+    grok.name('waeup.viewApplicationsTab')
+
+class ViewMyApplicationDataTab(grok.Permission):
+    grok.name('waeup.viewMyApplicationDataTab')
+
 class ManageApplication(grok.Permission):
     grok.name('waeup.manageApplication')
@@ -36,5 +42,6 @@
     grok.name('waeup.local.ApplicationOwner')
     grok.title(u'Application Owner')
-    grok.permissions('waeup.handleApplication', 'waeup.viewApplication')
+    grok.permissions('waeup.handleApplication', 'waeup.viewApplication',
+                     'waeup.Authenticated')
 
 # Site role
@@ -42,8 +49,9 @@
 class ApplicantRole(grok.Role):
     grok.name('waeup.Applicant')
-    grok.permissions('waeup.viewAcademics')
+    grok.permissions('waeup.viewAcademics', 'waeup.viewMyApplicationDataTab')
 
 class ApplicationsOfficer(grok.Role):
     grok.name('waeup.ApplicationsOfficer')
     grok.title(u'Applications Officer')
-    grok.permissions('waeup.manageApplication', 'waeup.viewApplication')
+    grok.permissions('waeup.manageApplication', 'waeup.viewApplication'
+                     'waeup.viewApplicationsTab')
Index: /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_applicant.py
===================================================================
--- /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_applicant.py	(revision 7239)
+++ /main/waeup.sirp/trunk/src/waeup/sirp/applicants/tests/test_applicant.py	(revision 7240)
@@ -32,8 +32,8 @@
 from waeup.sirp.interfaces import IFileStoreHandler, IFileStoreNameChooser
 from waeup.sirp.applicants import (
-    ResultEntry, Applicant, ApplicantFactory, get_regno_or_ac,
+    Applicant, ApplicantFactory, ApplicantsContainer,
     ApplicantImageStoreHandler, ApplicantImageNameChooser,
     )
-from waeup.sirp.applicants.interfaces import IResultEntry, IApplicant
+from waeup.sirp.applicants.interfaces import IApplicant
 from waeup.sirp.testing import FunctionalTestCase, FunctionalLayer
 
@@ -56,24 +56,4 @@
         super(HelperTests, self).tearDown()
         shutil.rmtree(self.workdir)
-        return
-
-    def test_get_regno_or_ac(self):
-        # we can get reg_no or access_code of an applicants if it is set
-        appl1 = Applicant()
-        appl2 = Applicant()
-        appl2.reg_no = u'foo'
-        appl3 = Applicant()
-        appl3.access_code = u'bar'
-        appl4 = Applicant()
-        appl4.reg_no = u'foo'
-        appl4.access_code = u'bar'
-        self.assertTrue(
-            get_regno_or_ac(appl1) is None)
-        self.assertEqual(
-            get_regno_or_ac(appl2), u'foo')
-        self.assertEqual(
-            get_regno_or_ac(appl3), u'bar')
-        self.assertEqual(
-            get_regno_or_ac(appl4), u'foo')
         return
 
@@ -124,79 +104,4 @@
         return
 
-class ApplicantImageNameChooserTests(FunctionalTestCase):
-
-    layer = FunctionalLayer
-
-    def test_iface(self):
-        # make sure we implement promised interfaces
-        obj = ApplicantImageNameChooser(None) # needs a context normally
-        verify.verifyClass(IFileStoreNameChooser, ApplicantImageNameChooser)
-        verify.verifyObject(IFileStoreNameChooser, obj)
-        return
-
-    def test_name_chooser_available(self):
-        # we can get a name chooser for applicant objects as adapter
-        appl = Applicant()
-        chooser = IFileStoreNameChooser(appl)
-        self.assertTrue(chooser is not None)
-        return
-
-    def test_name_chooser_applicant_wo_container(self):
-        # we can get an image filename for applicants not in a container
-        appl = Applicant()
-        appl.reg_no = u'MY_REG_NO'
-        chooser = IFileStoreNameChooser(appl)
-        result = chooser.chooseName()
-        # the file would be stored in a ``_default`` directory.
-        self.assertEqual(
-            result, '__img-applicant___default/MY_REG_NO.jpg')
-        return
-
-    def test_name_chooser_applicant_w_container(self):
-        appl = Applicant()
-        appl.reg_no = u'MY_REG_NO'
-        fake_container = grok.Container()
-        fake_container.__name__ = 'folder'
-        fake_container['appl'] = appl
-        appl.__parent__ = fake_container
-        chooser = IFileStoreNameChooser(appl)
-        result = chooser.chooseName()
-        self.assertEqual(
-            result, '__img-applicant__folder/MY_REG_NO.jpg')
-        return
-
-    def test_name_chooser_check_name(self):
-        # we can check file ids for applicants
-        appl = Applicant()
-        appl.reg_no = u'MY_REG_NO'
-        fake_container = grok.Container()
-        fake_container.__name__ = 'folder'
-        fake_container['appl'] = appl
-        appl.__parent__ = fake_container
-        chooser = IFileStoreNameChooser(appl)
-        result1 = chooser.checkName('foo')
-        result2 = chooser.checkName('__img-applicant__folder/MY_REG_NO.jpg')
-        self.assertEqual(result1, False)
-        self.assertEqual(result2, True)
-        return
-
-class ResultEntryTest(unittest.TestCase):
-
-    def setUp(self):
-        self.result_entry = ResultEntry()
-        return
-
-    def tearDown(self):
-        pass
-
-    def test_interfaces(self):
-        verify.verifyClass(IResultEntry, ResultEntry)
-        verify.verifyObject(IResultEntry, self.result_entry)
-
-    def test_resultentry(self):
-        entry = ResultEntry('Some subject', 3.7)
-        assert entry.subject == 'Some subject'
-        assert entry.score == 3.7
-
 class ApplicantTest(FunctionalTestCase):
 
@@ -235,5 +140,5 @@
 
     def test_factory(self):
-        obj = self.factory()
+        obj = self.factory(container=None)
         assert isinstance(obj, Applicant)
 
